SystemOrganization addCategory: 'OrbeonBizagiReader'!

Object subclass: #XPDLItemImportReport
	instanceVariableNames: 'type title description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader'!

!XPDLItemImportReport methodsFor: 'Accessing' stamp: 'BrunoBB 12/29/2014 05:10'!
description

   "Return the value of the instance variable 'description'."
   ^description! !

!XPDLItemImportReport methodsFor: 'Updating' stamp: 'BrunoBB 12/29/2014 05:10'!
description: newValue

   "Modify the value of the instance variable 'description'."
   description := newValue! !

!XPDLItemImportReport methodsFor: 'Accessing' stamp: 'BrunoBB 12/29/2014 05:13'!
title

   "Return the value of the instance variable 'title'."
   ^title! !

!XPDLItemImportReport methodsFor: 'Updating' stamp: 'BrunoBB 12/29/2014 05:13'!
title: newValue

   "Modify the value of the instance variable 'title'."
   title := newValue! !

!XPDLItemImportReport methodsFor: 'Accessing' stamp: 'BrunoBB 12/29/2014 05:10'!
type

   "Return the value of the instance variable 'type'."
   ^type! !

!XPDLItemImportReport methodsFor: 'Updating' stamp: 'BrunoBB 12/29/2014 05:10'!
type: newValue

   "Modify the value of the instance variable 'type'."
   type := newValue! !

Object subclass: #XPDLObject
	instanceVariableNames: 'attributes xmlString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader'!

XPDLObject subclass: #XPDLActivity
	instanceVariableNames: 'isStartActivity isEndActivity roles inTransitions outTransitions loopType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader'!

!XPDLActivity methodsFor: 'other' stamp: 'BrunoBB 12/28/2014 14:15'!
addInTransition: aXPDLTransition

	^inTransitions add: aXPDLTransition! !

!XPDLActivity methodsFor: 'other' stamp: 'BrunoBB 12/28/2014 14:15'!
addOutTransition: aXPDLTransition

	^outTransitions add: aXPDLTransition! !

!XPDLActivity methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 09:57'!
expectedResult

   "Return the value of the instance variable 'expectedResult'."
   ^expectedResult! !

!XPDLActivity methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 09:57'!
expectedResult: newValue

   "Modify the value of the instance variable 'expectedResult'."
   expectedResult := newValue! !

!XPDLActivity methodsFor: 'other' stamp: 'BrunoBB 03/11/2015 16:02'!
hasMixedStartConditions
	"Answer whether or not the receiver has mixed start conditions.
	Some out Transitions has start condition and some Transitions has NO start condition"

	^(outTransitions anySatisfy: [:each | each startCondition notNil])
		and:[outTransitions anySatisfy: [:each | each startCondition isNil]]! !

!XPDLActivity methodsFor: 'other' stamp: 'BrunoBB 03/12/2015 05:09'!
hasNoInOrOutTransitions

	^inTransitions isEmpty and:[outTransitions isEmpty]! !

!XPDLActivity methodsFor: 'other' stamp: 'BrunoBB 12/28/2014 14:15'!
initialize

	super initialize.

	isStartActivity := false.
	isEndActivity := false.
	inTransitions := OrderedCollection new.
	outTransitions := OrderedCollection new.! !

!XPDLActivity methodsFor: 'Accessing' stamp: 'BrunoBB 12/28/2014 14:17'!
inTransitions

   "Return the value of the instance variable 'inTransitions'."
   ^inTransitions! !

!XPDLActivity methodsFor: 'Updating' stamp: 'BrunoBB 12/28/2014 14:17'!
inTransitions: newValue

   "Modify the value of the instance variable 'inTransitions'."
   inTransitions := newValue! !

!XPDLActivity methodsFor: 'Accessing' stamp: 'BrunoBB 04/07/2015 05:38'!
isBasicActivity
	^true! !

!XPDLActivity methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 08:14'!
isEndActivity

   "Return the value of the instance variable 'isEndActivity'."
   ^isEndActivity! !

!XPDLActivity methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 08:14'!
isEndActivity: newValue

   "Modify the value of the instance variable 'isEndActivity'."
   isEndActivity := newValue! !

!XPDLActivity methodsFor: 'other' stamp: 'BrunoBB 04/06/2015 06:54'!
isGateway

	^false! !

!XPDLActivity methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 08:14'!
isStartActivity

   "Return the value of the instance variable 'isStartActivity'."
   ^isStartActivity! !

!XPDLActivity methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 08:14'!
isStartActivity: newValue

   "Modify the value of the instance variable 'isStartActivity'."
   isStartActivity := newValue! !

!XPDLActivity methodsFor: 'other' stamp: 'BrunoBB 12/27/2014 14:48'!
isStartOrEndActivity

	^self isStartActivity or: [self isEndActivity]! !

!XPDLActivity methodsFor: 'other' stamp: 'BrunoBB 01/18/2015 15:11'!
isSubProcess

	^false! !

!XPDLActivity methodsFor: 'Accessing' stamp: 'BrunoBB 06/15/2015 17:12'!
loopType
	^loopType! !

!XPDLActivity methodsFor: 'Updating' stamp: 'BrunoBB 06/15/2015 17:12'!
loopType: newValue
	loopType := newValue! !

!XPDLActivity methodsFor: 'other' stamp: 'BrunoBB 12/27/2014 12:23'!
originPoint

	^(self valueOf: 'x') @ (self valueOf: 'y')! !

!XPDLActivity methodsFor: 'Accessing' stamp: 'BrunoBB 12/28/2014 14:17'!
outTransitions

   "Return the value of the instance variable 'outTransitions'."
   ^outTransitions! !

!XPDLActivity methodsFor: 'Updating' stamp: 'BrunoBB 12/28/2014 14:17'!
outTransitions: newValue

   "Modify the value of the instance variable 'outTransitions'."
   outTransitions := newValue! !

!XPDLActivity methodsFor: 'other' stamp: 'BrunoBB 04/06/2015 14:05'!
printActivity

	^'[', self getName, ']'! !

!XPDLActivity methodsFor: 'other' stamp: 'BrunoBB 04/08/2015 05:47'!
printType

		^'Activity'! !

!XPDLActivity methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 11:11'!
roles

   "Return the value of the instance variable 'roles'."
   ^roles! !

!XPDLActivity methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 11:11'!
roles: newValue

   "Modify the value of the instance variable 'roles'."
   roles := newValue! !

!XPDLActivity methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 09:57'!
transitionPreviousFields

   "Return the value of the instance variable 'transitionPreviousFields'."
   ^transitionPreviousFields! !

!XPDLActivity methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 09:57'!
transitionPreviousFields: newValue

   "Modify the value of the instance variable 'transitionPreviousFields'."
   transitionPreviousFields := newValue! !

XPDLActivity subclass: #XPDLEndProcess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader'!

!XPDLEndProcess methodsFor: 'Accessing' stamp: 'BrunoBB 04/07/2015 05:38'!
isBasicActivity
	^false! !

!XPDLEndProcess methodsFor: 'other' stamp: 'BrunoBB 04/06/2015 14:05'!
printActivity

	^'(end)'! !

!XPDLEndProcess methodsFor: 'other' stamp: 'BrunoBB 04/08/2015 05:47'!
printType

		^'Process End'! !

XPDLActivity subclass: #XPDLGateway
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader'!

!XPDLGateway methodsFor: 'Accessing' stamp: 'BrunoBB 04/07/2015 05:38'!
isBasicActivity
	^false! !

!XPDLGateway methodsFor: 'other' stamp: 'BrunoBB 04/06/2015 14:08'!
isGateway

	^true! !

!XPDLGateway methodsFor: 'other' stamp: 'BrunoBB 04/06/2015 14:08'!
printActivity

	^'{', self getName, '}'! !

!XPDLGateway methodsFor: 'other' stamp: 'BrunoBB 04/08/2015 05:47'!
printType

		^'Gateway'! !

!XPDLGateway methodsFor: 'Accessing' stamp: 'BrunoBB 04/10/2015 05:03'!
type
	^type! !

!XPDLGateway methodsFor: 'Updating' stamp: 'BrunoBB 04/10/2015 05:03'!
type: newValue
	type := newValue! !

XPDLActivity subclass: #XPDLStartProcess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader'!

!XPDLStartProcess methodsFor: 'Accessing' stamp: 'BrunoBB 04/07/2015 05:38'!
isBasicActivity
	^false! !

!XPDLStartProcess methodsFor: 'other' stamp: 'BrunoBB 04/06/2015 14:05'!
printActivity

	^'(start)'! !

!XPDLStartProcess methodsFor: 'other' stamp: 'BrunoBB 04/08/2015 05:48'!
printType

		^'Process Start'! !

XPDLActivity subclass: #XPDLSubProcessActivity
	instanceVariableNames: 'parent parentId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader'!

!XPDLSubProcessActivity methodsFor: 'Accessing' stamp: 'BrunoBB 04/07/2015 05:38'!
isBasicActivity
	^false! !

!XPDLSubProcessActivity methodsFor: 'other' stamp: 'BrunoBB 01/18/2015 15:11'!
isSubProcess

	^true! !

!XPDLSubProcessActivity methodsFor: 'Accessing' stamp: 'BrunoBB 01/17/2015 14:10'!
parent

   "Return the value of the instance variable 'parent'."
   ^parent! !

!XPDLSubProcessActivity methodsFor: 'Updating' stamp: 'BrunoBB 01/17/2015 14:10'!
parent: newValue

   "Modify the value of the instance variable 'parent'."
   parent := newValue! !

!XPDLSubProcessActivity methodsFor: 'Accessing' stamp: 'BrunoBB 01/17/2015 14:10'!
parentId

   "Return the value of the instance variable 'parentId'."
   ^parentId! !

!XPDLSubProcessActivity methodsFor: 'Updating' stamp: 'BrunoBB 01/17/2015 14:10'!
parentId: newValue

   "Modify the value of the instance variable 'parentId'."
   parentId := newValue! !

!XPDLSubProcessActivity methodsFor: 'other' stamp: 'BrunoBB 04/06/2015 14:08'!
printActivity

	^'[@', self getName, ']'! !

!XPDLSubProcessActivity methodsFor: 'other' stamp: 'BrunoBB 04/08/2015 05:48'!
printType

		^'SubProcess Activity'! !

XPDLObject subclass: #XPDLane
	instanceVariableNames: 'activities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader'!

!XPDLane methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 12:43'!
activities

   "Return the value of the instance variable 'activities'."
   ^activities! !

!XPDLane methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 12:43'!
activities: newValue

   "Modify the value of the instance variable 'activities'."
   activities := newValue! !

!XPDLane methodsFor: 'other' stamp: 'BrunoBB 04/07/2015 04:49'!
includesActivity: aXPDLActivity

	^activities includes: aXPDLActivity! !

!XPDLane methodsFor: 'other' stamp: 'BrunoBB 12/27/2014 12:02'!
initialize

	super initialize.

	activities := OrderedCollection new.! !

!XPDLane methodsFor: 'other' stamp: 'BrunoBB 12/27/2014 12:19'!
rectangle

	^Rectangle origin: (self valueOf: 'x') @ (self valueOf: 'y') extent: (self valueOf: 'width') @ (self valueOf: 'height')! !

!XPDLane methodsFor: 'other' stamp: 'BrunoBB 04/07/2015 04:48'!
rectangleIncludesActivity: aXPDLActivity

	^self rectangle containsPoint: aXPDLActivity originPoint! !

!XPDLObject methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 11:49'!
attributes

   "Return the value of the instance variable 'attributes'."
   ^attributes! !

!XPDLObject methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 11:49'!
attributes: newValue

   "Modify the value of the instance variable 'attributes'."
   attributes := newValue! !

!XPDLObject methodsFor: 'other' stamp: 'BrunoBB 12/27/2014 11:52'!
getId

	^self valueOf: 'id'! !

!XPDLObject methodsFor: 'other' stamp: 'BrunoBB 12/27/2014 14:47'!
getName

	^self valueOf: 'name'! !

!XPDLObject methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 11:55'!
id: newValue

   "Modify the value of the instance variable 'id'."
	self set: 'id' value: newValue! !

!XPDLObject methodsFor: 'other' stamp: 'BrunoBB 12/27/2014 11:50'!
initialize

	super initialize.

	attributes := Dictionary new.! !

!XPDLObject methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 11:54'!
name: newValue

   "Modify the value of the instance variable 'name'."

	self set: 'name' value: newValue! !

!XPDLObject methodsFor: 'other' stamp: 'BrunoBB 12/27/2014 11:51'!
removeAttribute: attrName 

	^attributes removeKey: attrName ifAbsent: []! !

!XPDLObject methodsFor: 'other' stamp: 'BrunoBB 12/27/2014 11:50'!
set: attrName value: anObject

	^attributes at: attrName put: anObject! !

!XPDLObject methodsFor: 'other' stamp: 'BrunoBB 12/27/2014 11:51'!
valueOf: attrName

	^attributes at: attrName ifAbsent: [nil]! !

!XPDLObject methodsFor: 'Accessing' stamp: 'BrunoBB 12/26/2014 12:59'!
xmlString

   "Return the value of the instance variable 'xmlString'."
   ^xmlString! !

!XPDLObject methodsFor: 'Updating' stamp: 'BrunoBB 12/26/2014 12:59'!
xmlString: newValue

   "Modify the value of the instance variable 'xmlString'."
   xmlString := newValue! !

XPDLObject subclass: #XPDLProcess
	instanceVariableNames: 'processName activities transitions lanes originalProcessName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader'!

XPDLProcess subclass: #XPDLMainProcess
	instanceVariableNames: 'subProcesses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader'!

!XPDLMainProcess commentStamp: 'BrunoBB 03/13/2015 16:28' prior: 0!
It could be a Sub Process but "Reusable Sub Process"!

!XPDLMainProcess methodsFor: 'other' stamp: 'BrunoBB 01/18/2015 16:32'!
addSubProcess: aXPDLProcess

	^subProcesses add: aXPDLProcess! !

!XPDLMainProcess methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:57'!
initialize

	super initialize.

	subProcesses := OrderedCollection new.! !

!XPDLMainProcess methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:54'!
isMainProcess

	^true! !

!XPDLMainProcess methodsFor: 'Accessing' stamp: 'BrunoBB 01/16/2015 11:57'!
subProcesses

   "Return the value of the instance variable 'subProcesses'."
   ^subProcesses! !

!XPDLMainProcess methodsFor: 'Updating' stamp: 'BrunoBB 01/16/2015 11:57'!
subProcesses: newValue

   "Modify the value of the instance variable 'subProcesses'."
   subProcesses := newValue! !

!XPDLProcess methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 08:04'!
activities

   "Return the value of the instance variable 'activities'."
   ^activities! !

!XPDLProcess methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 08:04'!
activities: newValue

   "Modify the value of the instance variable 'activities'."
   activities := newValue! !

!XPDLProcess methodsFor: 'import report' stamp: 'BrunoBB 07/21/2015 14:26'!
appendFormsWithMissingMandatoryFieldsIn: anOrbeonApplication to: anOrderedCollection

	(activities reject: [:each | each isGateway])
		do:[:each | | def |
					def := anOrbeonApplication definitionNamed: each getName.
					def ifNotNil: [ 
						def getMandatoryFieldsMissing do: [:eachName | | item |
							item := XPDLItemImportReport new type: 'Error';
										title: 'Missing Mandatory Field';
										description: 'Form [', def form, '] in Orbeon Application [', anOrbeonApplication app, '] has NO mandatory field [', eachName ,']';
									yourself.
							anOrderedCollection add: item]]].

	^anOrderedCollection! !

!XPDLProcess methodsFor: 'import report' stamp: 'BrunoBB 12/29/2014 05:33'!
appendNonExistingFormsReportFor: anOrbeonApplication to: anOrderedCollection

	(self getNonExistingFormNamesIn: anOrbeonApplication) do: [:formName | | itemReport |
		itemReport := XPDLItemImportReport new type: 'Error';
			title: 'Missing Orbeon Form';
			description: 'Form [', formName, '] does not exist in Orbeon Application [', anOrbeonApplication app, ']';
			yourself.
		anOrderedCollection add: itemReport.].! !

!XPDLProcess methodsFor: 'import report' stamp: 'BrunoBB 12/29/2014 05:33'!
appendNonExistingRolesReportFor: anOrbeonApplication to: anOrderedCollection

	(self getNonExistingRolesNamesIn: anOrbeonApplication) do: [:rolName | | itemReport |
		itemReport := XPDLItemImportReport new type: 'Warning';
			title: 'Missing Role';
			description: 'Role named [', rolName, '] does not exist in Orbeon Application [', anOrbeonApplication app, ']';
			yourself.
		anOrderedCollection add: itemReport.].! !

!XPDLProcess methodsFor: 'import report' stamp: 'BrunoBB 10/01/2015 13:37'!
generateReportFor: appName
	| report application |

	report := OrderedCollection new.

	application := OrbeonApplication applicationNamed: appName ifNone: [(OrbeonApplication newNamed: appName) addToCache].

	self appendNonExistingFormsReportFor: application to: report.

	self appendFormsWithMissingMandatoryFieldsIn: application to: report.

	self appendNonExistingRolesReportFor: application to: report.

	^report! !

!XPDLProcess methodsFor: 'other' stamp: 'BrunoBB 03/13/2015 17:03'!
getAttributeNameOrName

	processName ifNil: [^self getName].

	^processName! !

!XPDLProcess methodsFor: 'other' stamp: 'BrunoBB 06/13/2015 16:00'!
getGateways

	^activities select: [:each | each isGateway]! !

!XPDLProcess methodsFor: 'other' stamp: 'BrunoBB 03/12/2015 05:08'!
getIsolatedActivities

	^activities select: [:each | each hasNoInOrOutTransitions]! !

!XPDLProcess methodsFor: 'other' stamp: 'BrunoBB 04/07/2015 04:57'!
getLaneFor: xpdlActivity ifNone: aBlock

	^lanes detect: [:each | each includesActivity: xpdlActivity] ifNone: aBlock! !

!XPDLProcess methodsFor: 'import report' stamp: 'BrunoBB 06/13/2015 16:32'!
getNonExistingFormNamesIn: anOrbeonApplication

	^((activities reject: [:each | each isGateway])
		reject: [:each | (anOrbeonApplication hasDefinitionNamed: each getName) 
															or:[each isStartOrEndActivity or:[each isSubProcess]]])
			collect: [:each | each getName]! !

!XPDLProcess methodsFor: 'import report' stamp: 'BrunoBB 12/29/2014 05:29'!
getNonExistingRolesNamesIn: anOrbeonApplication

	^(lanes reject: [:each | OrbeonFormRole hasRoleNamed:  each getName in: anOrbeonApplication])
			collect: [:each | each getName].! !

!XPDLProcess methodsFor: 'other' stamp: 'BrunoBB 01/18/2015 16:34'!
getSubProcessActivityNodes

	^activities select: [:each | each isSubProcess]! !

!XPDLProcess methodsFor: 'other' stamp: 'BrunoBB 03/12/2015 04:54'!
hasEndActivity

	^activities anySatisfy: [:each | each isEndActivity]! !

!XPDLProcess methodsFor: 'other' stamp: 'BrunoBB 03/12/2015 04:54'!
hasStartActivity

	^activities anySatisfy: [:each | each isStartActivity]! !

!XPDLProcess methodsFor: 'other' stamp: 'BrunoBB 12/27/2014 12:03'!
initialize

	super initialize.

	activities := OrderedCollection new.
	transitions := OrderedCollection new.
	lanes := OrderedCollection new.! !

!XPDLProcess methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:54'!
isMainProcess

	^false! !

!XPDLProcess methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:53'!
isSubProcess

	^false! !

!XPDLProcess methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 12:02'!
lanes

   "Return the value of the instance variable 'lanes'."
   ^lanes! !

!XPDLProcess methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 12:02'!
lanes: newValue

   "Modify the value of the instance variable 'lanes'."
   lanes := newValue! !

!XPDLProcess methodsFor: 'Accessing' stamp: 'BrunoBB 05/13/2015 06:10'!
originalProcessName
	^originalProcessName! !

!XPDLProcess methodsFor: 'Updating' stamp: 'BrunoBB 05/13/2015 06:10'!
originalProcessName: newValue
	originalProcessName := newValue! !

!XPDLProcess methodsFor: 'other' stamp: 'BrunoBB 04/06/2015 14:04'!
printActivities
	| stream |

	stream := PrintStream on: String new.

	transitions do: [:each | 
		stream nextPutAll: each printActivity;
					nextPutAll: String lf].

	^stream contents! !

!XPDLProcess methodsFor: 'other' stamp: 'BrunoBB 04/07/2015 04:52'!
printTransitions
	| stream |

	stream := PrintStream on: String new.

	transitions do: [:each | 
		stream nextPutAll: (each printTransitionFor: self);
					nextPutAll: String lf].

	^stream contents! !

!XPDLProcess methodsFor: 'Accessing' stamp: 'BrunoBB 03/13/2015 16:29'!
processName

   "Return the value of the instance variable 'processName'."
   ^processName! !

!XPDLProcess methodsFor: 'Updating' stamp: 'BrunoBB 03/13/2015 16:29'!
processName: newValue

   "Modify the value of the instance variable 'processName'."
   processName := newValue! !

!XPDLProcess methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 08:04'!
transitions

   "Return the value of the instance variable 'transitions'."
   ^transitions! !

!XPDLProcess methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 08:04'!
transitions: newValue

   "Modify the value of the instance variable 'transitions'."
   transitions := newValue! !

XPDLProcess subclass: #XPDLSubProcess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader'!

!XPDLSubProcess commentStamp: 'BrunoBB 03/13/2015 16:28' prior: 0!
Represent a BPMN "Embedded Subprocess".

XPDLMainProcess it could be a Sub Process but "Reusable Sub Process"!

!XPDLSubProcess methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 12:03'!
isEndActivity

	^false! !

!XPDLSubProcess methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 12:03'!
isStartActivity

	^false! !

!XPDLSubProcess methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 12:03'!
isStartOrEndActivity

	^false! !

!XPDLSubProcess methodsFor: 'other' stamp: 'BrunoBB 01/16/2015 11:54'!
isSubProcess

	^true! !

XPDLObject subclass: #XPDLProcessChain
	instanceVariableNames: 'allProcesses rootProcesses middleProcesses sheetProcesses definitions reader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader'!

!XPDLProcessChain class methodsFor: 'other' stamp: 'BrunoBB 01/27/2015 08:55'!
example1
	| procChain dict |

	dict := Dictionary new.
	dict at: 'd-perm-cons' put: 'ue'. 			"-ue- is anOrbeonApplication"
	dict at: 'd-perm-fabrica' put:  'agesic'.	"-agesic- is anOrbeonApplication"
	dict at: 'd-perm-inter' put:  'urcdp'.		"-urcdp- is anOrbeonApplication"

	procChain := XPDLProcessChain 
			from: #('/tmp/d-perm-cons.xpdl' '/tmp/d-perm-fabrica.xpdl' '/tmp/d-perm-inter.xpdl')
			in: dict.

	^procChain! !

!XPDLProcessChain class methodsFor: 'other' stamp: 'BrunoBB 04/07/2015 13:54'!
example2
	|d n |

	d := Dictionary new.
	n := Dictionary new.
	d at: 'Diagram 1' put: 'ue'.
	n at: 1 put: 'Diagram 1'.

	XPDLProcessChain from: #('/opt/gemstone/diagram.xpdl') in: d names: n.! !

!XPDLProcessChain class methodsFor: 'other' stamp: 'BrunoBB 01/24/2015 13:45'!
from: collectionPathFile in: orbeonAppDictionary

	^super new initialize
		createProcessFrom: collectionPathFile in: orbeonAppDictionary;
		yourself! !

!XPDLProcessChain class methodsFor: 'other' stamp: 'BrunoBB 03/13/2015 17:27'!
from: collectionPathFile in: orbeonAppDictionary names: processesNames

	^super new initialize
		createProcessFrom: collectionPathFile in: orbeonAppDictionary names: processesNames;
		yourself! !

!XPDLProcessChain methodsFor: 'other' stamp: 'BrunoBB 01/30/2015 04:09'!
addDefnitionsToCache

	definitions do: [:each | each addToCache]! !

!XPDLProcessChain methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2015 09:05'!
allProcesses

   "Return the value of the instance variable 'allProcesses'."
   ^allProcesses! !

!XPDLProcessChain methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2015 09:05'!
allProcesses: newValue

   "Modify the value of the instance variable 'allProcesses'."
   allProcesses := newValue! !

!XPDLProcessChain methodsFor: 'api' stamp: 'BrunoBB 03/13/2015 17:32'!
createProcessFrom: collectionPathFile in: orbeonAppDictionary
	"key -process name- value -orbeon application name-"
	| namesDictionary |

	namesDictionary := Dictionary new.
	allProcesses keysAndValuesDo: [:index :each | namesDictionary at: index put: each getName].

	^self createProcessFrom: collectionPathFile in: orbeonAppDictionary names: namesDictionary.! !

!XPDLProcessChain methodsFor: 'api' stamp: 'BrunoBB 10/01/2015 13:35'!
createProcessFrom: collectionPathFile in: orbeonAppDictionary names: procNamesDictionary
	"key -process name- value -orbeon application name-"
	| readers |

	readers := OrderedCollection new.
	collectionPathFile do: [:each | readers add: (BizagiXPDLReader for: each)].
	allProcesses := readers collect: [:each | each createProcessNode].

	reader := BizagiXPDLReader new.
	allProcesses keysAndValuesDo: [:index :each | | appName newDefinition |
		appName := orbeonAppDictionary at: each getName.
		each processName: (procNamesDictionary at: index). "we change the name (original file name) with html input name"
		each originalProcessName: (self getOriginalProcessNameFrom: (collectionPathFile at: index)).
		newDefinition := reader createProcessDefinitionIn: (OrbeonApplication applicationNamed: appName ifNone: [(OrbeonApplication newNamed: appName) addToCache])
									basedOn: each.
		"[each getName] is because the process name from the file was overide with <procNamesDictionary> [(procNamesDictionary at: index)].
		In order to set subprocesses we MUST use file name NOT #processName because in XPDLSubProcessActivity we use the name of the file"
		definitions at: each getName put: newDefinition].

	self setAllSubProcesses.! !

!XPDLProcessChain methodsFor: 'Accessing' stamp: 'BrunoBB 01/24/2015 13:35'!
definitions

   "Return the value of the instance variable 'definitions'."
   ^definitions! !

!XPDLProcessChain methodsFor: 'Updating' stamp: 'BrunoBB 01/24/2015 13:35'!
definitions: newValue

   "Modify the value of the instance variable 'definitions'."
   definitions := newValue! !

!XPDLProcessChain methodsFor: 'api' stamp: 'BrunoBB 01/21/2015 09:05'!
findSubProcessOf: aXPDLSubProcessActivity

	^allProcesses detect: [:each | | node |
			node := each xmlString.
			((node findElementNamed: 'Pool') attributeAt: 'Process') = aXPDLSubProcessActivity parentId]
			ifNone: [nil]! !

!XPDLProcessChain methodsFor: 'def warnings' stamp: 'BrunoBB 03/12/2015 17:44'!
getActivitiesWithMixedStartConditions
	"Answer a collection of <XPDLActivity> where some <XPDLTransition> has <startCondition> and others NOT.
	By general rule if a out Transition has a <startCondition> then all others out Transitions should have too.
	This is a only a Warning because could be a case where the previous does not apply"
	| report |

	report := OrderedCollection new.

	allProcesses do: [:eachProc | 
		(eachProc activities select: [:eachAct | eachAct hasMixedStartConditions]) do: [:eachAct | | reportItem |
			reportItem := XPDLItemImportReport new type: 'Warning';
				title: 'Mixed Start Conditions';
				description: 'Activity [', eachAct getName, '] in Process [', eachProc getName, '] has Mixed Start Conditions';
				yourself.
			report add: reportItem.
			]
	].
	^report! !

!XPDLProcessChain methodsFor: 'def warnings' stamp: 'BrunoBB 04/08/2015 05:45'!
getActivitiesWithoutName
	"Answer a collection of <XPDLActivity> without name.
	Activities MUST have a name."
	| report |

	report := OrderedCollection new.

	allProcesses do: [:eachProc | 
		(eachProc activities select: [:each | each getName isNil or:[each getName isEmpty]]) do: [:eachAct | | reportItem |
			reportItem := XPDLItemImportReport new type: 'Error';
				title: 'Activities without Name';
				description: 'Activity type [', eachAct printType, '] in Process [', eachProc getName, '] without name';
				yourself.
			report add: reportItem].
		].
	^report! !

!XPDLProcessChain methodsFor: 'def warnings' stamp: 'BrunoBB 04/08/2015 05:42'!
getActivitiesWithSameName
	"Answer a collection of <XPDLActivity> with the same name.
	Activities can NOT have the same name."
	| report |

	report := OrderedCollection new.

	allProcesses do: [:eachProc | | activitiesNames |
		activitiesNames := Dictionary new.
		(eachProc activities reject: [:each | each isStartOrEndActivity]) do: [:each | 
			activitiesNames at: each getName 
				ifPresent: [:value | activitiesNames at: each getName put: value + 1] 
				ifAbsent: [activitiesNames at: each getName put: 1].
		(activitiesNames select: [:each | each > 1]) keysAndValuesDo: [:key :value | | reportItem |
			reportItem := XPDLItemImportReport new type: 'Error';
				title: 'Activities with same Name';
				description: 'Activity [', key, '] in Process [', eachProc getName, '] is repeated';
				yourself.
			report add: reportItem].
		].
	].
	^report! !

!XPDLProcessChain methodsFor: 'other' stamp: 'BrunoBB 03/10/2015 15:58'!
getAllActivities
	| allActivities |

	allActivities := OrderedCollection new.

	allProcesses do: [:each | allActivities addAll: each activities].

	^allActivities! !

!XPDLProcessChain methodsFor: 'other' stamp: 'BrunoBB 03/10/2015 15:38'!
getAllSubProcessNodes
	| subProcNodes |

	subProcNodes := OrderedCollection new.

	allProcesses do: [:each | subProcNodes addAll: each getSubProcessActivityNodes].

	^subProcNodes! !

!XPDLProcessChain methodsFor: 'other' stamp: 'BrunoBB 05/22/2015 05:54'!
getAllTransitions
	| allTransitions |

	allTransitions := OrderedCollection new.

	allProcesses do: [:each | allTransitions addAll: each transitions].

	^allTransitions! !

!XPDLProcessChain methodsFor: 'def warnings' stamp: 'BrunoBB 07/21/2015 13:34'!
getGatewaysWithoutConditions
	""
	| report |

	report := OrderedCollection new.

	allProcesses do: [:eachProc | | activitiesNames |
		activitiesNames := Dictionary new.
		(eachProc activities reject: [:each | each isStartOrEndActivity]) do: [:each | 
			activitiesNames at: each getName 
				ifPresent: [:value | activitiesNames at: each getName put: value + 1] 
				ifAbsent: [activitiesNames at: each getName put: 1].
		(activitiesNames select: [:each | each > 1]) keysAndValuesDo: [:key :value | | reportItem |
			reportItem := XPDLItemImportReport new type: 'Error';
				title: 'Activities with same Name';
				description: 'Activity [', key, '] in Process [', eachProc getName, '] is repeated';
				yourself.
			report add: reportItem].
		].
	].
	^report! !

!XPDLProcessChain methodsFor: 'def warnings' stamp: 'BrunoBB 03/12/2015 05:00'!
getIsolatedActivities
	"Answer a collection of <XPDLActivity> where has not IN or OUT <XPDLTransition> "
	| report |

	report := OrderedCollection new.

	allProcesses do: [:eachProc | 
		eachProc getIsolatedActivities do: [:eachAct | | reportItem |
			reportItem := XPDLItemImportReport new type: 'Warning';
				title: 'Isolated Activity';
				description: 'Activity [', eachAct getName, '] in Process [', eachProc getName, '] is Isolated';
				yourself.
			report add: reportItem.
			]
	].
	^report! !

!XPDLProcessChain methodsFor: 'api' stamp: 'BrunoBB 05/13/2015 06:15'!
getOriginalProcessNameFrom: pathFileString
	"<pathFileString>
	/home/bruno/gsDevKitBruno/gemstone/stones/devKit/logs/tmp/permiso-contruccion.xpdl"

	^(pathFileString subStrings: '/') last allButLast: 5! !

!XPDLProcessChain methodsFor: 'other' stamp: 'BrunoBB 01/21/2015 09:59'!
getProcessAt: index

	^allProcesses at: index ifAbsent: [nil]! !

!XPDLProcessChain methodsFor: 'def warnings' stamp: 'BrunoBB 05/18/2015 13:00'!
getProcessWithMoreThanOneStartNode
	"Answer a collection of <XPDLProcess> that has more thatn one Start Node"
	| report |

	report := OrderedCollection new.

	allProcesses do: [:eachProc |  | reportItem |
			((eachProc activities select: [:each | each isStartActivity]) size > 1)
			ifTrue: [
				reportItem := XPDLItemImportReport new type: 'Error';
					title: 'Process with more than one Start';
					description: 'Process [', eachProc getName, '] has more than one Start Node';
					yourself.
				report add: reportItem].
	].
	^report! !

!XPDLProcessChain methodsFor: 'def warnings' stamp: 'BrunoBB 03/12/2015 05:06'!
getProcessWithoutEndNode
	"Answer a collection of <XPDLProcess> that has NO end node"
	| report |

	report := OrderedCollection new.

	allProcesses do: [:eachProc |  | reportItem |
			eachProc hasEndActivity 
			ifFalse:[
				reportItem := XPDLItemImportReport new type: 'Error';
					title: 'Process without End';
					description: 'Process [', eachProc getName, '] does NOT have End Node';
					yourself.
				report add: reportItem].
	].
	^report! !

!XPDLProcessChain methodsFor: 'def warnings' stamp: 'BrunoBB 03/12/2015 05:05'!
getProcessWithoutStartNode
	"Answer a collection of <XPDLProcess> that has NO start node"
	| report |

	report := OrderedCollection new.

	allProcesses do: [:eachProc |  | reportItem |
			eachProc hasStartActivity 
			ifFalse:[
				reportItem := XPDLItemImportReport new type: 'Error';
					title: 'Process without Start';
					description: 'Process [', eachProc getName, '] does NOT have Start Node';
					yourself.
				report add: reportItem].
	].
	^report! !

!XPDLProcessChain methodsFor: 'def warnings' stamp: 'BrunoBB 03/12/2015 17:44'!
getSubProcessNodesWithoutProcessDefinition
	"Answer a collection of <XPDLSubProcessActivity> where it's Process Definition is NOT defined in <allProcesses>.
	This will cause an error because some subprocesses are NOT defined"
	| allProcessNames report |

	report := OrderedCollection new.
	allProcessNames := allProcesses collect: [:each | each getName].

	allProcesses do: [:eachProc | 
		(eachProc getSubProcessActivityNodes reject: [:eachAct | allProcessNames includes: eachAct getName]) do: [:eachAct | | reportItem |
			reportItem := XPDLItemImportReport new type: 'Error';
				title: 'Sub Process Activity without Process Definition';
				description: 'Sub Process Activity [', eachAct getName, '] in Process  [', eachProc getName, '] has NO Process Definition';
				yourself.
			report add: reportItem.
			]
	].
	^report! !

!XPDLProcessChain methodsFor: 'def warnings' stamp: 'BrunoBB 05/22/2015 07:02'!
getSuspiciousConditions
	"Answer a collection with wrong or suspicious code inside gateways or transitions definitions.
	Conditions in gateways or transitions MUST answer a boolean and MUST send messages only to the argument of the Block.
	[:form | form amount >1000] is OK, but [:form | SomeClass doSomethigSuspicious] must be banned."
	| report |

	report := OrderedCollection new.

	(self getAllTransitions select: [:eachTr | eachTr startCondition notNil]) do: [:eachTr | | blockAnalysis | 
		blockAnalysis := OrbeonBlockAnalysis new blockCode: eachTr startCondition.
		blockAnalysis analyze.
		blockAnalysis codeWarnings do: [:eachString | | reportItem |
			reportItem := XPDLItemImportReport new type: 'Error';
				title: 'Suspicious Code';
				description: eachString;
				yourself.
			report add: reportItem.]].

	^report! !

!XPDLProcessChain methodsFor: 'other' stamp: 'BrunoBB 01/21/2015 09:59'!
getThirdProcess

	^self getProcessAt: 3! !

!XPDLProcessChain methodsFor: 'def warnings' stamp: 'BrunoBB 06/13/2015 15:57'!
getWarnings

	^self getActivitiesWithMixedStartConditions, 
		self getSubProcessNodesWithoutProcessDefinition,
		self getIsolatedActivities,
		self getProcessWithoutStartNode,
		self getProcessWithMoreThanOneStartNode,
		self getProcessWithoutEndNode,
		self getActivitiesWithSameName,
		self getActivitiesWithoutName,
		self getGatewaysWithoutConditions,
		self getSuspiciousConditions! !

!XPDLProcessChain methodsFor: 'def warnings' stamp: 'BrunoBB 03/11/2015 16:35'!
getWarningsFor: appsDict files: filesDict
	"Answer a collection of Warnings of the receiver related to Orbeon Application dictionary <appsDict> with uploaded dictionary files <filesDict>.
	<appsDict> the keys are indexes (1,2,3,N) and values are orbeon application names.
	<filesDict> the keys are indexes (1,2,3,N) and values are files names.
	Each index relate an Application name with the Uploaded file"
	| basicProcessWarnings orbeonWarnings |

	orbeonWarnings := OrderedCollection new.
	basicProcessWarnings := self getWarnings. "warnings that are independent from Orbeon Form Definitions"

	allProcesses keysAndValuesDo: [:index :xpdlProc | | reportItems |
		reportItems := xpdlProc generateReportFor: (appsDict at: index).
		orbeonWarnings addAll: reportItems].

	^basicProcessWarnings, orbeonWarnings! !

!XPDLProcessChain methodsFor: 'def warnings' stamp: 'BrunoBB 07/21/2015 14:39'!
hasAnyWarning

	^self getWarnings notEmpty! !

!XPDLProcessChain methodsFor: 'other' stamp: 'BrunoBB 01/25/2015 09:57'!
initialize

	super initialize.

	allProcesses := OrderedCollection new.
	rootProcesses := OrderedCollection new.
	middleProcesses := OrderedCollection new.
	sheetProcesses := OrderedCollection new.
	definitions := Dictionary new.! !

!XPDLProcessChain methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2015 09:05'!
middleProcesses

   "Return the value of the instance variable 'middleProcesses'."
   ^middleProcesses! !

!XPDLProcessChain methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2015 09:05'!
middleProcesses: newValue

   "Modify the value of the instance variable 'middleProcesses'."
   middleProcesses := newValue! !

!XPDLProcessChain methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2015 09:05'!
rootProcesses

   "Return the value of the instance variable 'rootProcesses'."
   ^rootProcesses! !

!XPDLProcessChain methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2015 09:05'!
rootProcesses: newValue

   "Modify the value of the instance variable 'rootProcesses'."
   rootProcesses := newValue! !

!XPDLProcessChain methodsFor: 'api' stamp: 'BrunoBB 01/21/2015 09:05'!
setAllProcessChain

	allProcesses do: [:eachProc | 
		eachProc getSubProcessActivityNodes do: [:each | 
			eachProc addSubProcess: (self findSubProcessOf: each).
		]
	]! !

!XPDLProcessChain methodsFor: 'api' stamp: 'BrunoBB 05/13/2015 06:21'!
setAllSubProcesses

	definitions do: [:eachDef | 
		eachDef endSubProcessNodes do: [:subProcNode | | def |
			def := definitions at: subProcNode nodeName ifAbsent: [nil].
			subProcNode processDefinition: def.
			def ifNotNil: [eachDef addSubProcess: def]].

		eachDef startSubProcessNodes do: [:subProcNode | | def |
			def := definitions at: subProcNode nodeName ifAbsent: [nil].
			def ifNotNil: [subProcNode processDefinition: def]].
	].! !

!XPDLProcessChain methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2015 09:05'!
sheetProcesses

   "Return the value of the instance variable 'sheetProcesses'."
   ^sheetProcesses! !

!XPDLProcessChain methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2015 09:05'!
sheetProcesses: newValue

   "Modify the value of the instance variable 'sheetProcesses'."
   sheetProcesses := newValue! !

XPDLObject subclass: #XPDLTransition
	instanceVariableNames: 'startId endId startNode endNode startCondition endCondition roles expectedResult transitionPreviousFields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader'!

!XPDLTransition methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 09:33'!
endCondition

   "Return the value of the instance variable 'endCondition'."
   ^endCondition! !

!XPDLTransition methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 09:33'!
endCondition: newValue

   "Modify the value of the instance variable 'endCondition'."
   endCondition := newValue! !

!XPDLTransition methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 07:55'!
endId

   "Return the value of the instance variable 'endId'."
   ^endId! !

!XPDLTransition methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 07:55'!
endId: newValue

   "Modify the value of the instance variable 'endId'."
   endId := newValue! !

!XPDLTransition methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 08:57'!
endNode

   "Return the value of the instance variable 'endNode'."
   ^endNode! !

!XPDLTransition methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 08:57'!
endNode: newValue

   "Modify the value of the instance variable 'endNode'."
   endNode := newValue! !

!XPDLTransition methodsFor: 'Accessing' stamp: 'BrunoBB 12/28/2014 12:02'!
expectedResult

   "Return the value of the instance variable 'expectedResult'."
   ^expectedResult! !

!XPDLTransition methodsFor: 'Updating' stamp: 'BrunoBB 12/28/2014 12:02'!
expectedResult: newValue

   "Modify the value of the instance variable 'expectedResult'."
   expectedResult := newValue! !

!XPDLTransition methodsFor: 'other' stamp: 'BrunoBB 03/12/2015 15:12'!
initialize

	super initialize.

	transitionPreviousFields:=  ''.
	roles := OrderedCollection new.! !

!XPDLTransition methodsFor: 'other' stamp: 'BrunoBB 04/06/2015 14:07'!
printTransition
	| stream |

	stream := PrintStream on: String new.

	stream nextPutAll: startNode printActivity ,' >> ', endNode printActivity.

	^stream contents! !

!XPDLTransition methodsFor: 'other' stamp: 'BrunoBB 04/07/2015 04:57'!
printTransitionFor: aXPDLProcess
	| stream lane |

	stream := PrintStream on: String new.

	lane := aXPDLProcess getLaneFor: endNode ifNone: [nil].
	lane := lane ifNil: ['<none>'] ifNotNil: ['<', lane getName, '>'].

	stream nextPutAll: startNode printActivity ,' >> ', endNode printActivity, ' - ', lane.

	^stream contents! !

!XPDLTransition methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 11:11'!
roles

   "Return the value of the instance variable 'roles'."
   ^roles! !

!XPDLTransition methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 11:11'!
roles: newValue

   "Modify the value of the instance variable 'roles'."
   roles := newValue! !

!XPDLTransition methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 09:33'!
startCondition

   "Return the value of the instance variable 'startCondition'."
   ^startCondition! !

!XPDLTransition methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 09:33'!
startCondition: newValue

   "Modify the value of the instance variable 'startCondition'."
   startCondition := newValue! !

!XPDLTransition methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 07:55'!
startId

   "Return the value of the instance variable 'startId'."
   ^startId! !

!XPDLTransition methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 07:55'!
startId: newValue

   "Modify the value of the instance variable 'startId'."
   startId := newValue! !

!XPDLTransition methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2014 08:57'!
startNode

   "Return the value of the instance variable 'startNode'."
   ^startNode! !

!XPDLTransition methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2014 08:57'!
startNode: newValue

   "Modify the value of the instance variable 'startNode'."
   startNode := newValue! !

!XPDLTransition methodsFor: 'Accessing' stamp: 'BrunoBB 12/28/2014 12:02'!
transitionPreviousFields

   "Return the value of the instance variable 'transitionPreviousFields'."
   ^transitionPreviousFields! !

!XPDLTransition methodsFor: 'Updating' stamp: 'BrunoBB 12/28/2014 12:02'!
transitionPreviousFields: newValue

   "Modify the value of the instance variable 'transitionPreviousFields'."
   transitionPreviousFields := newValue! !

Object subclass: #XPDLReader
	instanceVariableNames: 'xmlDocument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader'!

XPDLReader subclass: #BizagiXPDLReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader'!

!XPDLReader class methodsFor: 'other' stamp: 'BrunoBB 06/22/2015 13:18'!
for: xpdlPathFile
	| file contents | 

	file:= FileStream fileNamed: xpdlPathFile.
	contents := file contents.
	file close.

	^super new initialize
		xmlDocument: (XMLDOMParser parse: contents);
		yourself! !

!XPDLReader methodsFor: 'xpdl element' stamp: 'BrunoBB 06/15/2015 17:16'!
createActivityNodes
	| nodes |

	nodes := OrderedCollection new.
	xmlDocument allElementsNamed: 'Activity' do: [:eachNode | | newActivity |
		newActivity := (self getActivityInstanceFrom: eachNode)
			id: (eachNode attributeAt: 'Id');
			name: (eachNode attributeAt: 'Name');
			xmlString: eachNode; "remove this later"
			isStartActivity: (eachNode findElementNamed: 'StartEvent') notNil;
			isEndActivity: (eachNode findElementNamed: 'EndEvent') notNil;
			yourself.

		self setLoopTypeTo: newActivity withNode: eachNode.
		self setGraphicActivityValuesTo: newActivity withNode: eachNode.
		self setParentDataTo: newActivity withNode: eachNode.

		nodes add: newActivity.].

	^nodes! !

!XPDLReader methodsFor: 'xpdl element' stamp: 'BrunoBB 04/27/2015 16:14'!
createGatewayNodeWith: aXPDLActivity

	(aXPDLActivity type = 'Parallel') ifTrue: [^ParallelGatewayNode new nodeName: aXPDLActivity getName].

	(aXPDLActivity type = 'Inclusive') ifTrue: [^InclusiveGatewayNode new nodeName: aXPDLActivity getName].

	(aXPDLActivity type = 'Complex') ifTrue: [^ComplexGatewayNode new nodeName: aXPDLActivity getName].

	^ExclusiveGatewayNode new nodeName: aXPDLActivity getName! !

!XPDLReader methodsFor: 'xpdl element' stamp: 'BrunoBB 03/26/2015 07:07'!
createLaneNodes
	| nodes |

	nodes := OrderedCollection new.
	xmlDocument allElementsNamed: 'Lane' do: [:eachNode | | newLane |
		newLane := XPDLane new id: (eachNode attributeAt: 'Id');
			name: (eachNode attributeAt: 'Name');
			yourself.
		self setGraphicLaneValuesTo: newLane withNode: eachNode.
		nodes add: newLane.].

	^nodes! !

!XPDLReader methodsFor: 'definition creation' stamp: 'BrunoBB 06/16/2015 07:41'!
createProcessDefinitionIn: anOrbeonApplication basedOn: aXPDLProcess
	"Create a new <OrbeonFormProcessDefinition> in <anOrbeonApplication> based on the XPDL process definition <aXPDLProcess>"
	| processDefinition formsDefinitions version |

	processDefinition := OrbeonFormProcessDefinition new.
	processDefinition name: aXPDLProcess getAttributeNameOrName;
		orbeonApplication: anOrbeonApplication;
		xmlString: aXPDLProcess xmlString prettyPrinted.

	formsDefinitions := Dictionary new.
	"here we 'load' the dictionary <formsDefinitions> with instances of OrbeonFormDefinition, where the name is the key"	
	"at each XPDL Activity name the <formsDefinitions> Dictionary will have the related OrbeonFormDefinition"
	aXPDLProcess activities do: [:each | formsDefinitions at: each getName put: (anOrbeonApplication definitionNamed: each getName).
		processDefinition addLoopType: each loopType toFormNamed: each getName].

	"here we create all Transition Definitions for <processDefinition> based on <aXPDLProcess> with each activity been a OrbeonFormInstance in <formsDefinitions>"
	self createTransitionsDefinitionsIn: anOrbeonApplication for: processDefinition basedOn: aXPDLProcess using: formsDefinitions.

	"here we set the version of the new process, if nil --> is the first version (1) if not nil is the last version + 1"
	version := (OrbeonFormProcessDefinition getLatestVersionOf: processDefinition name in: anOrbeonApplication app) 
					ifNil: [1] 
					ifNotNilDo: [:def | def version + 1].

	^processDefinition version: version! !

!XPDLReader methodsFor: 'xpdl element' stamp: 'BrunoBB 01/18/2015 16:25'!
createProcessNode
	| newProcess |

	newProcess := XPDLMainProcess new.
	newProcess xmlString: xmlDocument.

	self setProcessIdTo: newProcess.
	self setProcessNameTo: newProcess.

	newProcess lanes: self createLaneNodes;
		activities: self createActivityNodes;
		transitions: self createTransitionNodes.

	self createRelationsInside: newProcess. "to connect activities and transitions"

	^newProcess! !

!XPDLReader methodsFor: 'xpdl element' stamp: 'BrunoBB 04/07/2015 04:49'!
createRelationsInside: aXPDLProcess
	| activities |

	activities := aXPDLProcess activities.

	aXPDLProcess transitions do: [:eachTr | "connect transition start and end node with XPLDActivities"
		eachTr startNode: 
				(activities detect: [:eachAct | eachAct getId = eachTr startId] ifNone: [nil]).
		eachTr endNode: 
				(activities detect: [:eachAct | eachAct getId = eachTr endId] ifNone: [nil]).
		eachTr startNode addOutTransition: eachTr.
		eachTr endNode addInTransition: eachTr.].

	aXPDLProcess lanes do: [:eachLane | "set the role of each transition -each activity inTransitions-"
		eachLane activities: (aXPDLProcess activities select: [:eachAct | eachLane rectangleIncludesActivity: eachAct]).
		eachLane activities do: [:eachAct | 
			eachAct inTransitions do: [:eachTr | eachTr roles: (OrderedCollection with: eachLane getName)]]].! !

!XPDLReader methodsFor: 'xpdl element' stamp: 'BrunoBB 03/26/2015 07:08'!
createSubProcessNodes
	| nodes |

	nodes := OrderedCollection new.
	xmlDocument allElementsNamed: 'ActivitySet' do: [:eachNode | | newSubProc |
		newSubProc := XPDLSubProcess new id: (eachNode attributeAt: 'Id');
			name: (eachNode attributeAt: 'Name');
			yourself.
		"self setGraphicLaneValuesTo: newSubProc withNode: eachNode."
		nodes add: newSubProc.].

	^nodes! !

!XPDLReader methodsFor: 'xpdl element' stamp: 'BrunoBB 03/26/2015 07:09'!
createTransitionNodes
	| nodes |

	nodes := OrderedCollection new.
	xmlDocument allElementsNamed: 'Transition' do: [:eachNode | | newTransition startCond |
		startCond := eachNode findElementNamed: 'Expression'.
		startCond ifNotNil: [startCond := startCond contentString].
		newTransition := XPDLTransition new id: (eachNode attributeAt: 'Id');
			name: (eachNode attributeAt: 'Name');
			startId: (eachNode attributeAt: 'From');
			endId: (eachNode attributeAt: 'To');
			startCondition: startCond;
			yourself.
		self setExtendedAttributesTo: newTransition withNode: eachNode.
		nodes add: newTransition.].

	^nodes! !

!XPDLReader methodsFor: 'definition creation' stamp: 'BrunoBB 04/07/2015 06:32'!
createTransitionsDefinitionsIn: anOrbeonApplication for: processDefinition basedOn: aXPDLProcess using: formsDefinitions
	"Create a new <OrbeonFormTransitionDefinition> for <processDefinition> based on the XPDL process definition <aXPDLProcess>.
	It use the OrbeonFormDefinitions contained in <formsDefinitions> to create the actual transition definition"

	aXPDLProcess transitions do: [:xpdlTran | | newTransition  | 
		newTransition := OrbeonFormTransitionDefinition new pathDefinition: processDefinition orbeonFormPathDefinition; "create the transition"
									startConditions: (OFNodeStartCondition fromString: xpdlTran startCondition); "set the conditions from <xpdlTran>"
									yourself.

		"create the initial and end node of <newTransition> and set <previousFields> and <expectedResult>.
		Take into account different type of nodes (BasicActivityNode, StartNode, EndNode, GatewayNode)"
		self setIntialAndEndNodeFor: newTransition withNode: xpdlTran using: formsDefinitions.

		xpdlTran roles notEmpty ifTrue: [newTransition grant: (OrbeonFormRole getNewRoleOrNamed: xpdlTran roles last in: anOrbeonApplication)]. "set roles"

		processDefinition addTransition: newTransition. "add the transition to the process definition"
		].! !

!XPDLReader methodsFor: 'xpdl element' stamp: 'BrunoBB 04/10/2015 05:07'!
getActivityInstanceFrom: eachNode

	(eachNode findElementNamed: 'SubFlow') ifNotNil: [^XPDLSubProcessActivity new].

	(eachNode findElementNamed: 'Route') 
	ifNotNil: [:node | | gate type | 
		gate := XPDLGateway new.
		type := node attributeAt: 'GatewayType' ifAbsent: ['']. "set the type of the gateway"
		^gate type: type].

	(eachNode findElementNamed: 'StartEvent') ifNotNil: [^XPDLStartProcess new].

	(eachNode findElementNamed: 'EndEvent') ifNotNil: [^XPDLEndProcess new].

	^XPDLActivity new! !

!XPDLReader methodsFor: 'definition creation' stamp: 'BrunoBB 04/27/2015 16:13'!
getEndNodeFrom: aXPDLActivity

	aXPDLActivity isSubProcess ifTrue: [^OrbeonSubProcessEndNode new nodeName: aXPDLActivity getName].

	aXPDLActivity isGateway ifTrue: [^self createGatewayNodeWith: aXPDLActivity].

	^OrbeonEndNode new nodeName: aXPDLActivity getName! !

!XPDLReader methodsFor: 'definition creation' stamp: 'BrunoBB 04/27/2015 16:13'!
getStartNodeFrom: aXPDLActivity

	aXPDLActivity isSubProcess ifTrue: [^OrbeonSubProcessStartNode new nodeName: aXPDLActivity getName].

	aXPDLActivity isGateway ifTrue: [^self createGatewayNodeWith: aXPDLActivity].

	^OrbeonStartNode new nodeName: aXPDLActivity getName! !

!XPDLReader methodsFor: 'other' stamp: 'BrunoBB 06/22/2015 05:45'!
setExtendedAttributesTo: newTransition withNode: xmlNode

	xmlNode allElementsNamed: 'ExtendedAttribute' do: [:eachAttr |
		((eachAttr attributeAt: 'Name') = 'expectedResult')  "-extended attribute- a TextArea in Bizagi Modeler (value is a XML)"
		ifTrue: [newTransition expectedResult: (XMLDOMParser parse: (eachAttr attributeAt: 'Value')) contentString].

		((eachAttr attributeAt: 'Name') = 'transitionPreviousFields') 
		ifTrue: [newTransition transitionPreviousFields: (eachAttr attributeAt: 'Value')]."-extended attribute- a TextBox in Bizagi Modeler (value is a string)"
	].! !

!XPDLReader methodsFor: 'other' stamp: 'BrunoBB 03/26/2015 07:10'!
setGraphicActivityValuesTo: newActivity withNode: xmlNode
	"We set the graphic information of <newActivity> using the XML node <xmlNode>"
	| gNode |

	gNode := xmlNode findElementNamed: 'Coordinates'.
	newActivity set: 'x' value: (Number readFrom: (gNode attributeAt: 'XCoordinate')).
	newActivity set: 'y' value: (Number readFrom: (gNode attributeAt: 'YCoordinate')).! !

!XPDLReader methodsFor: 'other' stamp: 'BrunoBB 03/26/2015 07:11'!
setGraphicLaneValuesTo: newLane withNode: xmlNode
	"We set the graphic information of <newLane> using the XML node <xmlNode>"
	| gNode |

	gNode := xmlNode findElementNamed: 'NodeGraphicsInfo'.
	newLane set: 'width' value: (Number readFrom: (gNode attributeAt: 'Width')).
	newLane set: 'height' value: (Number readFrom: (gNode attributeAt: 'Height')).

	gNode := xmlNode findElementNamed: 'Coordinates'.
	newLane set: 'x' value: (Number readFrom: (gNode attributeAt: 'XCoordinate')).
	newLane set: 'y' value: (Number readFrom: (gNode attributeAt: 'YCoordinate')).! !

!XPDLReader methodsFor: 'definition creation' stamp: 'BrunoBB 04/07/2015 06:30'!
setIntialAndEndNodeFor: newTransition withNode: xpdlTran using: formsDefinitions
	"The receiver set the start and end node for <newTransition> with xml segment <xpdlTran> for the mapping and dictionary <formsDefinitions> to get the OrbeonFormDefinitions"

	newTransition "set the start node with the form contained in <formsDefinitions>"
		startNodeWith: (formsDefinitions at: xpdlTran startNode getName ifAbsent: [nil]) node: (self getStartNodeFrom: xpdlTran startNode); 
			"set the end node with the form contained in <formsDefinitions>"
		endNodeWith: (formsDefinitions at: xpdlTran endNode getName ifAbsent: [nil]) node: (self getEndNodeFrom: xpdlTran endNode); 
		previousFields: ((xpdlTran transitionPreviousFields subStrings: ',') collect: [:each | each trimBlanks]); "set the variable #transitionPreviousFields "
		setExpectedResultFrom: xpdlTran expectedResult. "set the exptected resulta variable"! !

!XPDLReader methodsFor: 'other' stamp: 'BrunoBB 06/15/2015 17:19'!
setLoopTypeTo: newActivity withNode: xmlNode
	| loopNode |

	loopNode := xmlNode findElementNamed: 'Loop'.
	loopNode ifNil: [^self].

	^newActivity loopType: (loopNode attributeAt: 'LoopType')! !

!XPDLReader methodsFor: 'other' stamp: 'BrunoBB 01/18/2015 15:17'!
setParentDataTo: newActivity withNode: xmlNode
	"Set the XPDLActivity <newActivity> parentId value from <xmlNode>"

	newActivity isSubProcess ifFalse: [^self]. "if not a sub process then quit"

	newActivity parentId: ((xmlNode findElementNamed: 'SubFlow') attributeAt: 'Id')! !

!XPDLReader methodsFor: 'other' stamp: 'BrunoBB 06/22/2015 13:41'!
setProcessIdTo: newProcess
	"Only One Process (not including Bizagi Main Process) is imported. Any other process is ignored "
	| idNode |

	idNode := xmlDocument findElementNamed: 'Pool'.
	idNode ifNil: [^OrbeonInvalidXMLException signal: 'Not -Pool- node in XML file.'].

	newProcess id: (idNode attributeAt: 'Id')! !

!XPDLReader methodsFor: 'other' stamp: 'BrunoBB 06/22/2015 14:15'!
setProcessNameTo: newProcess
	"Only One Process (not including Bizagi Main Process) is imported. Any other process is ignored "
	| nameNode |

	nameNode := xmlDocument findElementNamed: 'Description'.
	nameNode ifNil: [^OrbeonInvalidXMLException signal: 'No -Description- node in XML file.'].

	^newProcess name: nameNode innerXML! !

!XPDLReader methodsFor: 'Accessing' stamp: 'BrunoBB 12/26/2014 12:59'!
xmlDocument

   "Return the value of the instance variable 'xmlDocument'."
   ^xmlDocument! !

!XPDLReader methodsFor: 'Updating' stamp: 'BrunoBB 12/26/2014 12:59'!
xmlDocument: newValue

   "Modify the value of the instance variable 'xmlDocument'."
   xmlDocument := newValue! !
